﻿// ConsoleApplication2.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
vector<vector<int>> neighbours;
vector<int> max_subtree;
vector<int> tin;
vector<int> tout;
int timer = 0;
void calculate_subtree(int vertex, int parent = -1) {
	int mx = -1;
	tin[vertex] = timer++;
	for (auto child : neighbours[vertex]) {
		if (child == parent)
			continue;
		calculate_subtree(child, vertex);
		mx = max(mx, max_subtree[child]);
	}
	tout[vertex] = timer;
	max_subtree[vertex] = mx + 1;
}
pair<int, int> dfs(int need, int vertex, int depth = 0, int parent = -1) {
	if (max_subtree[vertex]+depth <= need)
		return { max_subtree[vertex], 0 };
	if (max_subtree[vertex] == need - 1)
		return { -1, 1 };
	int result = 0;
	int cur_max_sub_tree = 0;
	for (auto child : neighbours[vertex]) {
		if (child == parent)
			continue;
		auto [child_subtree, need_to_up] = dfs(need, child, depth+1, vertex);
		result += need_to_up;
		cur_max_sub_tree = max(cur_max_sub_tree, child_subtree + 1);
	}
	if (cur_max_sub_tree == need-1 && cur_max_sub_tree+depth > need) {
		result++;
		cur_max_sub_tree = -1;
	}
	return { cur_max_sub_tree, result };
}
int main()
{
	int n, k, t;
	cin >> n >> k >> t;
	max_subtree.resize(n);
	neighbours.assign(n, vector<int>());
	tin.resize(n);
	tout.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		neighbours[u].push_back(v);
		neighbours[v].push_back(u);
	}
	for (int i = 0; i < n; i++) {
		calculate_subtree(i);
		int l = 1;
		int r = n-1;
		while (r >= l) {
			int mid = (r + l) / 2;
			if (dfs(mid, i).second > k) {
				l = mid + 1;
			}
			else
				r = mid - 1;
		}
		cout << l << ' ';
		if (t == 0)
			break;
	}
	cout << '\n';
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
