﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <bit>
using namespace std;
uint64_t m;
uint64_t non_fertile_population = 0;
uint64_t fertile_population = 0;
long long cur_time = 0;
bool is_power_of_2(uint64_t x) {
    if (x == 0)
        return false;
    return (x & (x - 1)) == 0;
}
int test(int next_time = 2e9) {
    if (next_time == cur_time)
        return -1;
    if (m == fertile_population + non_fertile_population)
        return 0;
    if (fertile_population == 0)
        return -1;
    if ((m - non_fertile_population) % fertile_population)
        return -1;
    auto d = (m - non_fertile_population) / fertile_population;
    if (!is_power_of_2(d))
        return -1;
    d = bit_width(d) - 1;
    if (cur_time + d >= next_time)
        return -1;
    return d;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n >> m;
    vector<pair<int, int>> events;
    vector<int> a(n), t(n);
    bool success = false;
    bool big_fail = false;
    for (auto& i : a) {
        cin >> i;
    }
    for (auto& i : t) {
        cin >> i;
    }
    for (int i = 0; i < n; i++) {
        events.push_back({ a[i], 0 });
        events.push_back({ a[i] + t[i], 1 });
    }
    sort(events.begin(), events.end());

    for (auto [time, type] : events) {
        int delta = test(time);
        if (delta != -1) {
            success = true;
            cur_time += delta;
            break;
        }
        if ((bit_width(fertile_population) + time - cur_time) > 50) {
            big_fail = true;
            break;
        }
        fertile_population <<= (time - cur_time);
        if (type == 0)
            non_fertile_population += 1;
        else {
            non_fertile_population -= 1;
            fertile_population += 2;
        }
        if (non_fertile_population + fertile_population > m) {
            break;
        }
        
        cur_time = time;
    }
    if (big_fail) {
        cout << -1 << '\n';
    }
    if (!success) {
        auto delta = test();
        if (delta != -1) {
            success = true;
            cur_time += delta;
        }
        else
            cur_time = -1;
    }
    cout << cur_time << '\n';
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
