﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <bit>
using namespace std;
struct segment_tree {
	vector<int> lazy, nodes;
	segment_tree(vector<int> arr) {
		int ext_arr_size = 1 << (bit_width(arr.size() - 1));
		lazy.assign(ext_arr_size, 0);
		nodes.resize(ext_arr_size*2);
		for (int i = 0; i < arr.size(); i++)
		{
			nodes[i + ext_arr_size] = arr[i];
		}
		for (int i = ext_arr_size - 1; i >= 1; i--)
		{
			nodes[i] = max(nodes[i * 2], nodes[i * 2 + 1]);
		}
	}
	void push(int node) {
		if (node >= lazy.size())
			return;
		int to_push = lazy[node];
		lazy[node] = 0;
		nodes[node * 2] += to_push;
		nodes[node * 2 + 1] += to_push;
		if (node * 2 >= lazy.size())
			return;
		lazy[node * 2] += to_push;
		lazy[node * 2 + 1] += to_push;
	}
	int query(int l, int r, int node_l, int node_r, int node) {
		if (r <= node_l || node_r <= l)
			return -1;
		if (l <= node_l && node_r <= r)
			return nodes[node];
		push(node);
		int mid = (node_l + node_r) / 2;
		return max(query(l, r, node_l, mid, node * 2), query(l, r, mid, node_r, node * 2 + 1));
	}
	void add(int l, int r, int x, int node_l, int node_r, int node) {
		if (r <= node_l || node_r <= l)
			return;
		if (l <= node_l && node_r <= r) {
			nodes[node] += x;
			if (node < lazy.size())
				lazy[node] += x;
			return;
		}
		push(node);
		int mid = (node_l + node_r) / 2;
		add(l, r, x, node_l, mid, node * 2);
		add(l, r, x, mid, node_r, node * 2 + 1);
	}
	int query(int l, int r) {
		return query(l, r, 0, lazy.size(), 1);
	}
	void add(int l, int r, int x) {
		add(l, r, x, 0, lazy.size(), 1);
	}

};
vector<int> tin, tout;
vector<int> preans;
vector<int> parent;
vector<int> values;
int timer = 0;
vector<int> left_child, right_child;
void time_dfs(int vertex) {
	if (vertex == -1)
		return;
	tin[vertex] = timer++;
	preans[tin[vertex]] = tin[vertex];
	time_dfs(left_child[vertex]);
	time_dfs(right_child[vertex]);
	tout[vertex] = timer;
}

int main()
{
	int n, q;
	cin >> n >> q;
	left_child.resize(n);
	right_child.resize(n);
	tin.resize(n);
	tout.resize(n);
	preans.resize(n);
	parent.resize(n);
	values.assign(n, -1);
	for (int i = 0; i < n; i++) {
		cin >> left_child[i] >> right_child[i];
		left_child[i]--;
		right_child[i]--;

	}
	time_dfs(0);
	segment_tree answer(preans);
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int l, r, x;
			cin >> l >> r >> x;
			for (int i = l - 1; i < r; i++) {
				for (; values[i] < x; values[i]++) {

					if (values[i] == -1) {
						if (left_child[i] == -1)
							continue;
						answer.add(tin[left_child[i]], tout[left_child[i]], -1);
						answer.add(tin[i], tin[i] + 1, tout[left_child[i]] - tin[left_child[i]]);
					}
					if (values[i] == 0) {
						if (right_child[i] == -1)
							continue;
						answer.add(tin[right_child[i]], tout[right_child[i]], -1);
						answer.add(tin[i], tin[i] + 1, tout[right_child[i]] - tin[right_child[i]]);
					}
				}
			}
			for (int i = l - 1; i < r; i++) {
				for (; values[i] > x; values[i]--) {

					if (values[i] == 0) {
						if (left_child[i] == -1)
							continue;
						answer.add(tin[left_child[i]], tout[left_child[i]], 1);
						answer.add(tin[i], tin[i] + 1, -tout[left_child[i]] + tin[left_child[i]]);
					}
					if (values[i] == 1) {
						if (right_child[i] == -1)
							continue;
						answer.add(tin[right_child[i]], tout[right_child[i]], 1);
						answer.add(tin[i], tin[i] + 1, -tout[right_child[i]] + tin[right_child[i]]);
					}
				}
			}
		}
		else {
			int x;
			cin >> x;
			x--;
			cout << answer.query(tin[x], tin[x] + 1) + 1 << '\n';
		}
	}
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
